import pandas as pd
from pathlib import Path

import wmfdata as wmf
from wmfdata.utils import print_err

from .utils import (
    find_metric_file,
    load_metric_file,
    prepare_date_params
)

class MetricSet:
    """
    A MetricSet is a group of monthly metrics that is saved to a single file and
    which is generated by one or more queries.
    
    Class assumptions:
    * Each query contains a "month" column which Pandas can parse into a date.
    * The column names used in the queries are unique across queries.
    
    A note on the date formats:
    The month column is saved to the file as the ISO-8601 date of the start of the
    month (e.g. 2020-06-01). However, in Python we handle them not as Datetimes but as
    Periods, since this makes it easy to write code (e.g. utils.calc_rpt) which works
    both with the normal monthly as well as quarterly aggregates.
    """
    
    def __init__(self, filename, queries):
        self.filename = filename
        self.filepath = find_metric_file(filename)
        self.queries = queries
        self.load_data()

    def load_data(self):
        try:
            self.data = load_metric_file(self.filename)
        except FileNotFoundError:
            self.data = pd.DataFrame()

    def add_data(self, new_data):
        """
        Takes a Pandas data frame with a date index giving the month and one or more
        columns of metrics.
        """
        # Our policy is to avoid altering previously-generated data (which can happen
        # because some of our data sources regenerate history every month). If you do want
        # to regenerate some data, manually delete it from the data file.
        
        # Store the original order of columns from self.data
        original_order = self.data.columns.tolist()
     
        self.data = self.data.combine_first(new_data)[original_order]
 
    def run_queries(self, metrics_month_text, cleanup_function=None):
        date_params = prepare_date_params(metrics_month_text)
        
        for key, val in self.queries.items():
            query = Path(val["file"]).read_text().format(**date_params)
            print_err(f"Running {key} ")

            result = wmf.spark.run(query)
            
            if cleanup_function:
                result = cleanup_function(result)

            result = (
                result
                .assign(month=lambda df: pd.to_datetime(df["month"]))
                .set_index("month")
                # This dataframe will usually have only a single row, so
                # Pandas will not be able to infer the frequency of the period
                .to_period("M")
            )
            
            self.add_data(result)

    def save_data(self):
        self.data.to_timestamp().to_csv(self.filepath, sep="\t")
